(use simple-cells simple-exceptions simple-tests
  (only data-structures list-of?))

(define-test (cells?)
  (check
    (define o% (cell 5 number? odd?))
    (cell? o%)
    (not (condition-case (o% 4) ((exn argument) #f)))
    (= (o%) 5)
    (define n% (cell 4 (named-lambda 3<=? (x) (<= 3 x))))
    (= (n%) 4)
    ((list-of? procedure?) (receive (val checks) (n%) checks))
    (= (n% 20) 4)
    (= (n%) 20)
    (= (o%) 5)
    ((list-of? procedure?) (receive (val checks) (o%) checks))
    (define lst (map cell '(0 1 2 3 4)))
    (= ((list-ref lst 3)) 3)
    (= ((list-ref lst 3) 30) 3)
    (= ((list-ref lst 3)) 30)
    ))


(compound-test (SIMPLE-CELLS)
  (cells?)
  )

